$Id: README.ru,v 1.14 2008/09/11 20:47:58 yuk Exp $

1. Что такое mapchan и для чего она

mapchan - программа, позволяющая произвольным образом преобразовывать
терминальный ввод-вывод. Она полезна, если:

  * вы желаете работать в разных кодировках на различных виртуальных
    экранах консоли
  * вы являетесь счастливым обладателем зоопарка терминалов, ни
    один из которых не поддерживает вашу любимую кодировку

Данная реализация является неполным функциональным аналогом 
утилиты mapchan из SCO Unix. 

Это не "грязный хак", требующий вмешательства в ядро ОС, а достаточно 
стандартная программа, использующая механизм "псевдотерминала". 
Как результат, она не является Linux-специфической, и должна работать 
практически под любым Unix.


2. Установка

Процесс установки исполняемых файлов традиционен:

  make
  make install

map-файлы рекомендуется ложить в /etc/mapchan

3. Запуск

Формат командной строки:

  mapchan [-q] [-s shell] [-f map-файл] [-u codeset] [-p терминал] [-h]

  ключи:

    -q - "тихий" запуск, без каких-либо сообщений
    -s - позволяет указать имя запускаемого shell'а.
         Умолчание - /bin/sh
    -p - Выбирать из указанных псевдотерминалов.
         В качестве аргумента может быть указано:
         - ключевое слово "auto" - определяет автовыбор первого свободного
           псевдотерминала в классическом стиле из диапазона /dev/ttya0-zf
         - ключевое слово "unix98" - определяет автовыбор 
           псевдотерминала в стиле Unix'98 (/dev/pty/0...n)
         - точное имя псевдотерминала в классическом стиле, 
           напр. "/dev/ttyc1"
         - диапазон имен псевдотерминалов в классическом стиле, 
           напр. "/dev/ttyc1-d5"
         - комбинация из элементов предыдущих двух пунктов, разделенных
           запятыми
	 УМОЛЧАНИЕ: Если данный ключ не указывается, то устройство
         терминала создается динамически в стандарте Unix'98 -
         как "/dev/pts/N"
    -f - имя map-файла.
         Умолчание - считывается из /etc/mapchan/default
    -u - из какой кодировки выполнять преобразование в UTF-8.
    -P - пауза (2 сек.) при открытии терминала.
    -x - не менять состояние параметров ixon/ixoff для псевдотерминала.
         По умолчанию отключаются оба.
    -h - вывод короткой подсказки.

ВНИМАНИЕ! Запуск mapchan без параметров не приводит к выводу
--------- подсказки с последующим завершением программы.
          В этом случае mapchan пытается запуститься в соответствии
          с /etc/mapchan/default

Запускать mapchan лучше всего из пользовательского profile,
одним из двух способов:

1) Создав в /etc/mapchan файл default (образец можете найти в examples),
   укажите для каждой терминальной линии, какой map-файл должен
   браться. Формат файла default:

   <имя_терминала_1> <имя_map-файла>
   <имя_терминала_2> <имя_map-файла>
   ....

   Затем поместите в конец пользовательского profile строку типа:

   mapchan -q -s mc

2) Можно все функции выбора map-файла переложить на profile,
   поместив в конец его конструкцию типа:

   if [ "$TERM" == "sm7238"]; then
      mapchan -f /etc/mapchan/sm7238.map -s user_prog
   else
      user_prog
   fi

3.1 Преобразование в UTF-8

Начиная с версии 3.0 поддерживается стандартное преобразование любой
известной однобайтной кодировки в мультибайтную кодировку UTF-8 с помощью
механизма 'iconv'. Обратная перекодировка пока не реализована.

Примеры:

1) Предположим, у вас имеется приложение oldprog, работающее в кодировке 
DOS CP866.

Тогда вы сможете запускать его в терминале, имеющем рабочую кодировку UTF-8,
следующим образом:

  mapchan -u CP866 -s "oldprog arg1 arg2 arg3"

2) Если вам необходимо заходить по ssh с вашего UTF-терминала на хост kserver, 
в котором основной кодировкой является KOI8-R - вы можете сделать это 
следующей командой:

  mapchan -u KOI8-R -s "ssh kserver"

Полный список доступных кодировок можно посмотреть с помощью команды:

  iconv --list

Наиболее часто применяемые однобайтные кирилличные кодировки:

  KOI8-R - наиболее общепринятая в различных Unix-системах
  KOI8-U - то же, дополненное украинскими буквами
  CP866  - используется в MS-DOS
  CP1125 - "альтернативная" кодировка DOS, отличается от
           предыдущей расположением украинских букв
  CP1251 - используется в MS Windows
  ISO8859_5 - стандарт ISO, применялся в некоторых коммерческих Unix'ах

4. Формат map-файла

   Имеются следующие отличия от SCO-шного стадарта:

   - пока нет поддержки тега `beep'
   - нет поддержки тега `compose' (вряд ли он нужен в реальной жизни)
   - возможен только один тег `dead'

   map-файл может включать:
   
   - комментарии, начинающиеся с `#'
   - пустые строки
   - секцию отображения вывода, начинающуюся с тега `output'
   - секцию отображения ввода, начинающуюся с тега `input'
   - необязательную подсекцию отображения ввода, начинающуюся 
     с тега `dead'
   
Каждая секция содержит произвольное количество строк, каждая из которых
определяет преобразование входного или выходного символа. Формат строки:

<символ> <во что преобразуется>

Элементы строки преобразования могут разделяться пробелами для 
удобочитаемости.

Символ и элементы преобразования могут быть представлены в виде:

   0777 - число, начинающееся с `0' - восьмеричный код
   0xAA - число, начинающееся с `0x' - шестнадцатиричный код
   99 - число, начинающееся с десятичной цифры - десятичный код
   'A'  - символ в кавычках - сам этот символ
   A    - алфавитный символ - сам этот символ

4.1. Секция control

Формат секции control в приципе отличается от стандарта SCO.
В моей версии она служит для описания управляющих символов
(пока что одиночных), выполняющих отключение и обратное включение 
процесса перекодировки. 

Это полезно, когда по обслуживаемой линии необходимо передать данные 
не для отображения на терминале, например, при печати на локальный 
принтер.

Формат строки:

'-' <символ, по которому будет отключаться перекодировка>
'+' <символ, по которому перекодировка будет снова включена>

4.2. Секция esc(

Данная секция имеется только в этой версии mapchan. Действует
подобно output, но производит только перекодировку последовательностей

ESC ( символ

которые используются для переключения текущего кодового набора. 
Например, в случае наличия в map-файле секции вида

esc(
'B' 0x1B '(' 'K'

выводимая на экран esc-последовательность ESC(B будет преобразовываться 
в ESC(K.


5. Примеры

В каталоге examples/ содержатся образцы файлов:

	default 	- файл описания соответствий линия - mapfile

Mapfiles:

	altkoi.map	- программы в альтернативной кодировке DOS, 
			  терминал - koi8-r
	koiualt.map	- программы в koi8-u, терминал - в альтернативной
	koiumain.map	- программы в koi8-u, терминал - в основной кодировке
			  ГОСТ
	k180.map	- аналогично предыдущему + возможность отключения
                          перекодировки (секция control)
	sm7238.map	- программы в koi8-u, терминал - СМ7238 в режиме
			  "УП.РУС" (символы - осн. кодировка ГОСТ,
                          псевдографика - vt100) 
	dos2koi.map	- программы в CP-866, терминал - koi8-r
	win2koi.map	- программы в CP-1251, терминал - koi8-r
